//
// Created by q1w2e3r4 on 23-7-28.
//

#include "HIR-opt/HOptUtils.h"
#include <cstring>
// Replace oldVal with newVal in all usages of oldVal
void Replace(ValueRef* oldVal, ValueRef* newVal){
    for(auto instr:oldVal->use){
        instr->replace(oldVal,newVal);
    }
}

// delete this block, and update all blocks pred/succ it;
void DelBlock(Function* func, BasicBlock *block) {
    for(auto pre: block->pred){
        for(auto it = pre->succ.begin(); it != pre->succ.end(); ++it){
            if(*it == block){
                pre->succ.erase(it);
                break;
            }
        }
    }

    for(auto nxt: block->succ){
        for(auto it = nxt->pred.begin(); it != nxt->pred.end(); ++it){
            if(*it == block){
                nxt->pred.erase(it);
                break;
            }
        }
    }

    auto& v = func->block_list;
    for(auto it = v.begin(); it != v.end(); ++it){
        if((*it) == block){
            v.erase(it);
        }
    }
    delete(block);
}
